import comtypes.client
from comtypes.client import CreateObject, GetActiveObject
import comtypes.gen.AutoCAD as ACAD
import comtypes.gen.AXDBLib as AXDBLib
# import pythoncom
# import logging
import win32com.client                                                  # For Application connection
import pythoncom 
from pyautocad import Autocad,APoint,aDouble,aInt,aShort
import array
import random as rand
import time
import os
import sys
import glob
global maxbasex , maxbasey , minbasex , minbasey
def vtpt(x, y, z=0):
    return win32com.client.VARIANT(pythoncom.VT_ARRAY | pythoncom.VT_R8, (x, y, z))

def vtobj(obj):
    return win32com.client.VARIANT(pythoncom.VT_ARRAY | pythoncom.VT_DISPATCH, obj)

def vtFloat(lis):
    """ list converted to floating points"""
    return win32com.client.VARIANT(pythoncom.VT_ARRAY | pythoncom.VT_R8, lis)

def vtint(val):
    return win32com.client.VARIANT(pythoncom.VT_ARRAY | pythoncom.VT_I2, val)

def vtvariant(var):
    return win32com.client.VARIANT(pythoncom.VT_ARRAY | pythoncom.VT_VARIANT, var)
def diaxdata(dia, slope, obj):
    dataType = (1001, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040)                 # Define Xdata
    data = ('Diameter',dia * 10 , slope ,3 , 0.7 , .013 , 0 , 0 ,  0 ,  2 ,  1)
    dataType = vtint(dataType)                          # Converse dataType format
    data = vtvariant(data)
    obj.SetXData(dataType, data)    
def delss(setss):
    try:
        doc.SelectionSets.Item("SS1").Delete()
    except:
        a="Delete selection failed"



try:
        acad = win32com.client.Dispatch("AutoCAD.Application")  

except:
        print ("AutoCAD isn't running!")

doc = acad.ActiveDocument #Document Object
model = doc.ModelSpace
acad.application.Visible = True
AppActivate = acad.application.Caption
print(AppActivate)

doc.Layers.Add("Pview")
layerObj = doc.Layers.Add("EGOUT")
doc.Layers.Add("EDIT")
layerObj = doc.Layers.Add("sewer")
layerObj.Color = 1
layerObj = doc.Layers.Add("area")
layerObj.Color = 6
layerObj = doc.Layers.Add("area-pline")
lyerObj = doc.Layers.Add("Den-pline")
layerObj.Color = 5
layerObj = doc.Layers.Add("area-density")
layerObj.Color = 3
layerObj = doc.Layers.Add("density")
layerObj = doc.Layers.Add("Latral")
layerObj.Color = 5
layerObj = doc.Layers.Add("SHEET-index")
layerObj = doc.Layers.Add("Grid")
layerObj =doc.Layers.Add("POP-TXT")
layerObj.Color = 4
layerObj = doc.Layers.Add("Elevation")
layerObj.Color = 7
layerObj =doc.Layers.Add("GELV")
layerObj.Color = 2
layerObj =doc.Layers.Add("Pview")
doc.ActiveLayer =doc.Layers("sewer")
print('Current Layer=' , doc.ActiveLayer.Name)   

delss('ss1')
ssget1 = doc.SelectionSets.Add("SS1")
   

SELECT_ALL = int(5) # 5=variable de autocad para selecionar todo

    #selecciona entidad circulo, Codigo dxf=0, Filterdata="Circle"
#selecciona radio del circulo, Codigo dxf=40, Filerdata=10, Todos los cirulos con radio =10
    #selecciona layer, Codigo dxf=8, Filterdata="uno", y que estan en el layer uno
    
valor=vtpt(0,0,0) #Necesario para parte del filtro
FilterType=vtint((0,8))
FilterData=vtvariant(('Line','Sewer'))

    #selecionar de acuerdo al criterio de filtro

ssget1.Select(SELECT_ALL,valor,valor,FilterType,FilterData)

    #Contar entidades
icount = ssget1.Count 
print(icount)
maxbasex = 0.00 
maxbasey = 0.00
if ssget1.Count > 0 :
    maxbasex = ssget1(0).startpoint
    maxbasey = maxbasex[1]
    maxbasex = maxbasex[0]
    minbasey = maxbasey
    minbasex = maxbasex

    print (maxbasex , maxbasey)
    for iobj in ssget1:
        point1 = iobj.startpoint
        if maxbasex < point1[0]:
            maxbasex = point1[0]
        if maxbasey < point1[1]:
             maxbasey = point1[1]
        if minbasex > point1[0]:
            minbasex = point1[0]
        if minbasey > point1[1]:
            minbasey = point1[1]
        point1 = iobj.endpoint
        if maxbasey < point1[1]:
            maxbasey = point1[1]
        if maxbasex < point1[0]:
            maxbasex = point1[0]
        if minbasey > point1[1]:
            minbasey = point1[1]    
    #if minbasex > point1[0]:
       #minbasex = point1[0]      
        print ('maxx',maxbasex ,'maxy',maxbasey)
#print ('minx',minbasex,'miny',minbasey)

delss('ss1')
ssget1 = doc.SelectionSets.Add("SS1")
alor=vtpt(0,0,0) #Necesario para parte del filtro
FilterType=vtint((0,8))
FilterData=vtvariant(('Circle','Egout'))

    #selecionar de acuerdo al criterio de filtro
ssget1.Select(SELECT_ALL,valor,valor,FilterType,FilterData)

    #Contar entidades
icount = ssget1.Count 

print(icount)

if icount == 0 :
        txtobj = model.AddText( 'EGOUT' , vtpt(maxbasex + 100  ,maxbasey + 100   ), 100 )
        txtobj.Alignment = 4
        txtobj.TextAlignmentPoint = vtpt(maxbasex + 100  ,maxbasey + 100   )
        for i in range( 20 , 40 ,5):
            cirobj = model.AddCircle(vtpt(maxbasex + 100,maxbasey  + 100), i//2 )
            cirobj.layer = "EGOUT"
           
            diaxdata(i , 0.004 , cirobj)
        for i in range(50, 110 , 10):
            cirobj = model.AddCircle(vtpt(maxbasex + 100,maxbasey + 100), i//2 )
            cirobj.layer = "EGOUT"
            diaxdata(i, 0.001,cirobj)
            dataType = (1001, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1000, 1040)                   # Define Xdata
            data = ("Criteria",0 , 0 ,100, 100 , 0 , 0 , 0 ,  0 ,  1 ,  0, "N", 5)
            dataType = vtint(dataType)                          # Converse dataType format
            data = vtvariant(data)
            txtobj.SetXData(dataType, data) 
            dataType = (1001, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040)                   # Define Xdata
            data = ( "Runoff",0 , 0 , 0, 0 , 0 , 180 , 0 ,  0 ,  1 , .5, 4, 1)
            dataType = vtint(dataType)                          # Converse dataType format
            data = vtvariant(data)
            txtobj.SetXData(dataType, data)            
            dataType = (1001, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040)  # Define Xdata
            data = ( "Infiltration",0 , 0 , 0, 0 , 0 , 0, 0 , 0, 0 , 0 , 0)
            dataType = vtint(dataType)                          # Converse dataType format
            data = vtvariant(data)
            txtobj.SetXData(dataType, data)     
            dataType = (1001, 1040, 1040, 1040, 1040, 1040, 1040,1040, 1040, 1040, 1040)           # Define Xdata
            data = ( "Population",0 , 0 , 0, 0 , 0 , 0, 0, 0 , 0 , 0)
            dataType = vtint(dataType)                          # Converse dataType format
            data = vtvariant(data)
            
            txtobj.SetXData(dataType, data) 
            dataType = (1001, 1000, 1000, 1000, 1000, 1000, 1000, 1000,1040, 1040, 1040, 1040)           # Define Xdata
            data = ( "Title", ' 1' , '2 ' , '3 ', '4 ' , ' 5' , ' 6' , '7', 0 , 0 , 0 , 0)
            dataType = vtint(dataType)                          # Converse dataType format
            data = vtvariant(data)
            txtobj.SetXData(dataType, data)   
             
            dataType = (1001, 1040, 1040, 1040, 1040, 1040, 1040, 1040)           # Define Xdata
            data = ( "Sheetindex",0 , 0 , 0, 0 , 0 , 0, 0)
            dataType = vtint(dataType)                          # Converse dataType format
            data = vtvariant(data)
            
            txtobj.SetXData(dataType, data)   
                  
              
print ('Acad load')

